#include <Wire.h>

#define address 0x35

void setup() {
   //
   // start serial and I2C
   //
   delay(10000);
   Serial.begin(9600);
   Wire.begin();
   Wire.setClock(400000);
   //
   // reset TLE493D
   //
   Wire.beginTransmission(address);
   Wire.write(0xFF);
   Wire.endTransmission();
   Wire.beginTransmission(address);
   Wire.write(0xFF);
   Wire.endTransmission();
   Wire.beginTransmission(address);
   Wire.write(0x00);
   Wire.endTransmission();
   Wire.beginTransmission(address);
   Wire.write(0x00);
   Wire.endTransmission();
   delayMicroseconds(50);
   //
   // configure TLE493D
   //
   Wire.beginTransmission(address);
   Wire.write(0x10);
   Wire.write(0x28);
      // config register 0x10
      // ADC trigger on read after register 0x05
      // short-range sensitivity
   Wire.write(0x15);
      // mode register 0x11
      // 1-byte read protocol
      // interrupt disabled
      // master controlled mode
   Wire.endTransmission();
   }

void loop() {
   uint8_t data[6];
   int transformedData1[3];
   
   //
   // read data
   //
   Wire.requestFrom(address,6);
   for (int i = 0; i < 6; ++i) {
    data[i] = Wire.read();
   }

   transformedData1[0] = (data[0] << 4)+((data[4] & 0xF0) >> 4);
   transformedData1[1] = (data[1] << 4)+(data[4] & 0x0F);
   transformedData1[2] = (data[2] << 4)+(data[5] & 0x0F);

   /*for (int i = 0; i < 6; ++i) {
    Serial.print(data[i]);
    Serial.print(' ');
   }
   Serial.print('\n');*/
   for (int i = 0; i < 3; ++i) {
    if (transformedData1[i] > 2047) transformedData1[i] -= 4096;
    Serial.print(transformedData1[i]);
    Serial.print(' ');
   }
   Serial.print('\n');
   delay(500);
}
